-- by "Marhu" 
-- v 1.0
-- Date: 02.04.2013
-- to send Filling Status for KuhZuchtZE handle in Place

KuhZuchtUpdateFillLvlEvent = {};
KuhZuchtUpdateFillLvlEvent_mt = Class(KuhZuchtUpdateFillLvlEvent, Event);

InitEventClass(KuhZuchtUpdateFillLvlEvent, "KuhZuchtUpdateFillLvlEvent");

function KuhZuchtUpdateFillLvlEvent:emptyNew()
    local self = Event:new(KuhZuchtUpdateFillLvlEvent_mt);
    return self;
end;
    
function KuhZuchtUpdateFillLvlEvent:new(object, Lvl)
	local self = KuhZuchtUpdateFillLvlEvent:emptyNew()
	self.object = object;
	self.Lvl = Lvl;
	return self;
end;

function KuhZuchtUpdateFillLvlEvent:readStream(streamId, connection)
	--print("readStream")
	local id = streamReadInt32(streamId);
	self.Lvl = streamReadFloat32(streamId);
	self.object = networkGetObject(id);
	self:run(connection);
end;

function KuhZuchtUpdateFillLvlEvent:writeStream(streamId, connection)
	--print("writeStream")
	streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteFloat32(streamId, self.Lvl);
end;

function KuhZuchtUpdateFillLvlEvent:run(connection)
	if not connection:getIsServer() then
		g_server:broadcastEvent(self, false, connection, self.object);
	end;
	if self.object ~= nil then
		self.object:sendFillLevel(self.Lvl, true);
	end;
end;

function KuhZuchtUpdateFillLvlEvent.sendEvent(objekt, Lvl, noEventSend)
	
	--print("sendEvent")
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(KuhZuchtUpdateFillLvlEvent:new(objekt, Lvl), nil, nil, objekt);
		else
			g_client:getServerConnection():sendEvent(KuhZuchtUpdateFillLvlEvent:new(objekt, Lvl));
		end;
	end;

end;